require 'optparse'
require_relative 'db'
require_relative 'cli'
require_relative 'version'

module Comcalc
  class Client

    attr_accessor :options

    def initialize(argv)
      @options = {}
      @argv = argv
      extract_options
    end

    def execute!
      cli = Comcalc::Cli
      if @options[:add]
        cli.new.menu
      else
        puts @optparse
        exit
      end
    end

    def extract_options
      @optparse = OptionParser.new do |opts|
        opts.banner = "Usage: comcalc [options] ..."
        @options[:add] = false
        opts.on( '-m', '--menu', 'Add ip to your Connection list' )
          @options[:add] = true
        opts.on( '-h', '--help', 'Display this screen' ) do
          puts opts
          exit
        end
        opts.on( '-v', '--version', 'Print programs version' ) do
          puts Comcalc::VERSION
          exit
        end
      end
      @optparse.parse(@argv)
    end
  end
end
