require 'sqlite3'
require 'debugger'
require 'fileutils'

module Comcalc
  class Database

    FileUtils.mkdir_p("#{File.join(ENV['HOME'])}/.config/comcalc/") unless Dir.exists?("#{ENV['HOME']}/.config/comcalc")
    FileUtils.cp ("#{File.dirname(__FILE__)}/../../config/wgdb.db"), ("#{File.join(Dir.home)}" + '/.config/comcalc/') unless File.exists?(("#{File.join(Dir.home)}" + '/.config/comcalc/wgdb.db'))
    path = "#{File.join(ENV['HOME'])}/.config/comcalc"
    DATABASE = SQLite3::Database.open "#{path}/wgdb.db"

    def query(table, column, value)
      call = DATABASE.prepare ("SELECT * FROM #{table} WHERE #{column}=?")
      call.execute(value).each do |row|
        puts row.join "\s"
      end
    end

    def query_spec(column1='',column2='',column3='', table)
      # check for solution with arbirtraty params
      # *?
      DATABASE.execute("SELECT #{column1}, #{column2}, #{column3} FROM #{table}").each do |x|
        x.each do |y|
          print "#{y} "
        end
        puts "\n"
      end
    end

    def get_person_id_from_bill id
      DATABASE.execute("SELECT person_id from bill where id=#{id}")
    end


    def refactored_get_single_value(column, table, condition, term)
      DATABASE.execute("SELECT #{column} FROM #{table} where #{condition}=#{term}")
    end

    def get_amount_from_bill(id)
      DATABASE.execute("SELECT value FROM bill where id=#{id}")
    end

    def get_involved_ppl(id)
      DATABASE.execute("SELECT person_id FROM involved_in_bill where bill_id=#{id}")
    end

    # show statistics

    def get_all_persons
      DATABASE.execute("SELECT id, first_name, last_name FROM person").each do |x|
        puts "use: #{x[0]} for #{x[1]}"
      end
    end

    def insert_into_bill(id, value, date, market_id, person_id, note)
      DATABASE.execute("INSERT INTO bill (id, value, date, market_id, person_id, note) VALUES (?,?,?,?,?,?)",[id, value, date, market_id, person_id, note])
    end

    def add_new_person(id, first_name, last_name, balance, created_at)
      DATABASE.execute("INSERT INTO person (id, first_name, last_name, balance, created_at) VALUES (?,?,?,?,?)",[id, first_name, last_name, balance, created_at])
    end

    def get_last_bill_id
      call = DATABASE.execute("SELECT id from bill")
      call.last[0]
    end

    def get_market
      DATABASE.execute("SELECT id, name FROM market").each do |x|
        puts "use: #{x[0]} for #{x[1]}"
      end
    end

    def update_market_count(id)
      DATABASE.execute("update market set count=count+1 where id=#{id}")
    end

    def update_balance_payer(id, new_balance)
      DATABASE.execute("update person set balance=balance+#{new_balance} where id=#{id}")
    end

    def update_balance_involved(id, new_balance)
      DATABASE.execute("update person set balance=balance-#{new_balance} where id=#{id}")
    end

    def involved_in_bill(id,person_id,bill_id)
      DATABASE.execute(("INSERT INTO involved_in_bill (id, person_id, bill_id) VALUES (?,?,?)"),[id,person_id,bill_id])
    end

    def monthly_data(column, table)
      DATABASE.execute("SELECT #{column} from #{table} where date > date('now','-1 month')")
    end

    def monthly_data_person(column, table, person_id)
      DATABASE.execute("SELECT #{column} from #{table} where date > date('now','-1 month') and person_id=#{person_id}")
    end

    def get_name_by_id(id)
      DATABASE.execute("SELECT first_name from person where id=#{id}")
    end
  end
end

